Bug 2327 fix to verify ipaddress in sol003_02 testsuite
[osm/tests.git] / robot-systest / run_test.sh
1 #!/usr/bin/env bash
2
3 ##
4 # Copyright 2020 ATOS
5 #
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License");
9 # you may not use this file except in compliance with the License.
10 # You may obtain a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS,
16 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
17 # See the License for the specific language governing permissions and
18 # limitations under the License.
19 ##
20
21 cat /dev/zero | ssh-keygen -q -N "" > /dev/null
22
23 install_osmclient(){
24 echo -e "\nInstalling osmclient ${OSMCLIENT}"
25 python3 -m pip install git+https://osm.etsi.org/gerrit/osm/osmclient@${OSMCLIENT}
26 }
27
28 download_packages(){
29 echo -e "\nDownloading packages ${PACKAGES}"
30 rm -rf ${PACKAGES_FOLDER}
31 git clone https://osm.etsi.org/gitlab/vnf-onboarding/osm-packages.git ${PACKAGES_FOLDER}
32 }
33
34 download_tst010(){
35 # Fetch conformance tests
36 git clone --single-branch --branch ${NFV_TESTS_BRANCH} https://forge.etsi.org/rep/nfv/api-tests.git /robot-systest/conformance-tests/repo
37 #python3 -m pip install -r /robot-systest/conformance-tests/repo/requirements.txt
38 python3 -m pip install -r /robot-systest/conformance-tests/requirements.txt
39 }
40
41
42 create_k8scluster(){
43 attempts=3
44 while [ $attempts -ge 0 ] ; do
45 echo -e "\n$( date '+%F_%H:%M:%S' ) Creating K8s Cluster"
46
47 osm k8scluster-add --creds ${K8S_CREDENTIALS} --version "v1" --vim ${VIM_TARGET} --k8s-nets "{\"net1\": \"${VIM_MGMT_NET}\"}" ${VIM_TARGET} --description "Robot cluster" --skip-jujubundle
48
49 STATUS=""
50 i=0
51 while [[ ${STATUS} != "ENABLED" ]]
52 do
53 ((i++))
54 if [[ $i -eq 5 ]]; then
55 echo "K8s cluster stuck for more than 50 seconds:"
56 osm k8scluster-show ${VIM_TARGET}
57 osm k8scluster-delete ${VIM_TARGET}
58 sleep 5
59 break
60 fi
61 sleep 10
62 STATUS=`osm k8scluster-list | grep ${VIM_TARGET} | awk '{print $8}'`
63 done
64 if [[ ${STATUS} = "ENABLED" ]] ; then
65 break
66 fi
67 ((attempts--))
68 done
69 if [ $attempts -lt 0 ] ; then
70 echo "K8s cluster failed to enter ENABLED state"
71 exit 1
72 fi
73 }
74
75 create_vim(){
76 attempts=3
77 while [ $attempts -ge 0 ] ; do
78 echo -e "\n$( date '+%F_%H:%M:%S' ) Creating VIM ${VIM_TARGET}"
79 osm vim-create --name ${VIM_TARGET} --user ${OS_USERNAME} --password ${OS_PASSWORD} --tenant ${OS_PROJECT_NAME} \
80 --auth_url ${OS_AUTH_URL} --account_type openstack --description vim \
81 --config "{management_network_name: ${VIM_MGMT_NET}, dataplane_physical_net: ${DATAPLANE:-physnet2}}" || true
82 STATUS=""
83 i=0
84 while [[ ${STATUS} != "ENABLED" ]]
85 do
86 ((i++))
87 if [[ $i -eq 5 ]]; then
88 echo "VIM stuck for more than 50 seconds as: ${VIM_LIST}"
89 osm vim-delete --force ${VIM_TARGET}
90 sleep 5
91 break
92 fi
93 sleep 10
94 VIM_LIST=`osm vim-list --long | grep ${VIM_TARGET}`
95 echo VIM status: ${VIM_LIST}
96 STATUS=`echo ${VIM_LIST} | grep -io ENABLED`
97 done
98 if [[ ${STATUS} = "ENABLED" ]] ; then
99 break
100 fi
101 ((attempts--))
102 done
103 if [ $attempts -lt 0 ] ; then
104 echo "VIM failed to enter ENABLED state"
105 exit 1
106 fi
107 }
108
109
110 create_sdnc(){
111 if [ -n "${SDNC_URL}" ]; then
112 osm sdnc-create --name sdnc-osm --type ${SDNC_TYPE} --user ${SDNC_USER} --password ${SDNC_PASSWORD} --url ${SDNC_URL}
113 COUNTER=0
114 STATUS=""
115 while [ ${COUNTER} -lt 5 ] ; do
116 echo "Checking status of SDNC sdnc-osm to see if it is enabled"
117 STATUS=$(osm sdnc-show sdnc-osm |grep -io ENABLED)
118 if [ "${STATUS}" == "ENABLED" ]; then
119 break
120 fi
121 ((COUNTER++))
122 sleep 10
123 done
124 if [ "${STATUS}" == "ENABLED" ]; then
125 echo "SDNC enabled"
126 else
127 echo "SDNC failed to enter ENABLED state"
128 osm sdnc-show sdnc-osm
129 exit 1
130 fi
131 if [ -f /root/port-mapping.yaml ]; then
132 osm vim-update ${VIM_TARGET} --sdn_controller sdnc-osm --sdn_port_mapping /root/port-mapping.yaml
133 COUNTER2=0
134 RESULT=""
135 while [ ${COUNTER2} -lt 5 ] ; do
136 echo "Checking status of VIM $VIM_TARGET to see if there is port-mapping"
137 osm vim-show $VIM_TARGET |grep sdn-port-mapping
138 if [ $? -eq 0 ]; then
139 RESULT="OK"
140 break
141 fi
142 ((COUNTER2++))
143 sleep 10
144 done
145 if [ "${RESULT}" == "OK" ]; then
146 echo "Port-mapping correctly added"
147 else
148 echo "Port-mapping failed to be added"
149 osm vim-show ${VIM_TARGET}
150 exit 1
151 fi
152 fi
153 fi
154
155 }
156
157
158 PARAMS=""
159 RUN_CONFORMANCE_TESTS=false
160
161 while (( "$#" )); do
162 case "$1" in
163 -t|--testingtags)
164 TEST=$2
165 shift 2
166 ;;
167 -p|--packagesbranch)
168 PACKAGES=$2 && download_packages
169 shift 2
170 ;;
171 -o|--osmclientversion)
172 OSMCLIENT=$2 && install_osmclient
173 shift 2
174 ;;
175 -c|--createvim)
176 create_vim
177 # create_sdnc
178 create_k8scluster
179 shift 1
180 ;;
181 -T)
182 NFV_TESTS_BRANCH=$2 && download_tst010
183 RUN_CONFORMANCE_TESTS=true
184 shift 1
185 ;;
186 -h|--help)
187 echo "OSM TESTS TOOL
188
189 Usage:
190 docker run --rm=true -t osmtests --env-file <env_file> \\
191 -v <path_to_reports>:/reports osmtests \\
192 -v <path_to_clouds.yaml>:/robot-systest/clouds.yaml \\
193 -v <path_to_kubeconfig>:/root/.kube/config \\
194 -o <osmclient_version> \\
195 -p <package_branch> \\
196 -t <testing_tags>
197
198 Options:
199 --env-file: It is the environmental file where is described the OSM target and VIM
200 -o <osmclient_version> [OPTIONAL]: It is used to specify a particular osmclient version. Default: latest
201 -p <package_branch> [OPTIONAL]: OSM packages repository branch. Default: master
202 -t <testing_tags> [OPTIONAL]: Robot tests tags. [sanity, daily, regression, particular_test]. Default: sanity
203 -T <testing_branch> [OPTIONAL]: Run SOL005 Robot conformance tests
204 -c To create a VIM and K8s cluster for the tests
205
206 Volumes:
207 <path_to_reports> [OPTIONAL]: It is the absolute path to reports location in the host
208 <path_to_clouds.yaml> [OPTIONAL]: It is the absolute path to the clouds.yaml file in the host
209 <path_to_kubeconfig> [OPTIONAL]: It is the kubeconfig file to be used for k8s clusters"
210
211 exit 0
212 ;;
213 -*|--*=)
214 echo "Error: Unsupported flag $1" >&2
215 exit 1
216 ;;
217 *)
218 PARAMS="$PARAMS $1"
219 shift
220 ;;
221 esac
222 done
223
224 eval set -- "$PARAMS"
225
226 if [[ -n "$BRANCH_NAME" ]]; then
227 PACKAGES=$BRANCH_NAME && download_packages
228 OSMCLIENT=$BRANCH_NAME && install_osmclient
229 fi
230
231
232 if [ "$RUN_CONFORMANCE_TESTS" = true ] ; then
233 python3 ${ROBOT_DEVOPS_FOLDER}/conformance-tests/run_conformance_tests.py
234 fi
235
236 if [[ -n "${TEST}" ]]; then
237 robot -d ${ROBOT_DEVOPS_FOLDER}/reports --tagstatinclude "cluster_*" -i ${TEST} ${ROBOT_DEVOPS_FOLDER}/testsuite/
238 else
239 echo "No test was provided. Exiting..."
240 fi
241
242 exit 0